--
-- Rolles
-- author: werik
--

Rolles = {};

function Rolles.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function Rolles:load(xmlFile)
	self.rollNodes = {};
	
    local rollNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roll#index"));
    if rollNode ~= nil then
        local speed = 0.003*3;
        table.insert(self.rollNodes, {node=rollNode, speed=speed});
    end;
    local i = 0;
    while true do
        local key = string.format("vehicle.rolls.roll(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local rollNode = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
        local speed = Utils.getNoNil(getXMLFloat(xmlFile, key.."#speed"), 0.003);
        if rollNode ~= nil then
            table.insert(self.rollNodes, {node=rollNode, speed=speed});
        end;
        i = i + 1;
    end;
end;

function Rolles:readStream(streamId, connection)
end;

function Rolles:writeStream(streamId, connection)
end;

function Rolles:delete()
end;

 
function Rolles:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Rolles:keyEvent(unicode, sym, modifier, isDown)
end;
 
function Rolles:update(dt)
	--if self:getIsActive() then
		if self.isTurnedOn then
			for _, rollNode in pairs(self.rollNodes) do
				rotate(rollNode.node, -dt*rollNode.speed, 0, 0);
			end;
		end;
	--end;
end;

function Rolles:onLeave()
end;

function Rolles:draw()
end;
